#include <semaphore.h>
#include <unistd.h>
#include "list.hpp"    // list implementation
#include "globals.hpp" // lists, sems, muts
#include "producer.hpp"

void produce(block* b);

void *producer (void *) {
   while (true) {

      wait(sem_freelist); // wait for freelist not empty
      wait(mut_freelist); // lock freelist
      block *b = list_unlink(freelist);
      signal(mut_freelist); // unlock freelist

      //* Produce information in block b
      produce(b);

      wait(mut_list1); // lock l1
      list_link(list1, b);
      signal(mut_list1); // unlock l1
      signal(sem_list1);

   }
   return nullptr;
}

void produce(block *b) {
   usleep(65*timescale);
   return;
}
