#include <semaphore.h>
#include <unistd.h>
#include "list.hpp"    // list implementation
#include "globals.hpp" // lists, sems, muts
#include "transformer.hpp"

void transform(block* x, block* y);

void *transformer (void *) {
   block *x, *y;
   while (true) {

      wait(sem_list1);
      wait(mut_list1);
      x = list_unlink(list1);
      signal(mut_list1);

      wait(sem_freelist);
      wait(mut_freelist);
      y = list_unlink(freelist);
      signal(mut_freelist);

      //* use block x to produce info in y
      transform(x, y);

      wait(mut_freelist);
      list_link(freelist, x);
      signal(mut_freelist);
      signal(sem_freelist);

      wait(mut_list2);
      list_link(list2, y);
      signal(mut_list2);
      signal(sem_list2);

   }
   return nullptr;
}

void transform(block *x, block *y) {
   usleep(55*timescale);
   return;
}
