#include <semaphore.h>
#include <unistd.h>
#include "list.hpp"    // list implementation
#include "globals.hpp" // lists, sems, muts
#include "consumer.hpp"

#define unlink(x) list_unlink(x)
#define link(x)   list_link(x)

int consume(block* c);

void *consumer (void *) {
   while (true) {

      wait(sem_list2);
      wait(mut_list2);
      block* c = list_unlink(list2);
      signal(mut_list2);

      //* consume information in block c
      consume(c);

      wait(mut_freelist);
      list_link(freelist, c);
      signal(mut_freelist);
      signal(sem_freelist);

   }
   return nullptr;
}

int consume(block *c) {
   usleep(75*timescale);
   return c->data;
}
